;TITLE POKER
;AUTHOR entropy
;COMMANDS poker(0)
;VERSION: 1.1
;HELP poker [On/Off/Fold/Top10/Bid/Discard 1 2 3 4 5]|Toggles poker On/Off, or sets the various settings.|none

;============================== ALIASES
alias -l cticks { return $+($calc(($ticks - $1) / 1000),s) }
alias -l royalflush {
  if (A isin $1- && K isin $1- && Q isin $1 && J isin $1 && 10 isin $1) {
    if ($remove($1-,$chr(32),A,K,Q,J,10) == SSSSS || $remove($1-,$chr(32),A,K,Q,J,10) == CCCCC || $remove($1-,$chr(32),A,K,Q,J,10) == DDDDD || $remove($1-,$chr(32),A,K,Q,J,10) == HHHHH) { return 14 } 
  }
}
alias -l straightflush {
  var %a = 1, %b = $replace($remove($1-,S,C,D,H),A,14,J,11,Q,12,K,13), %d = $replace($1-,A,14,J,11,Q,12,K,13)
  if ($istok(%b,14,32) && $istok(%b,2,32) && $istok(%b,3,32) && $istok(%b,4,32) && $istok(%b,5,32)) {
    var %c = $remove(%d,$chr(32),2,3,4,5,6,7,8,9,10,11,12,13,14)
    if (%c == SSSSS || %c == CCCCC || %c == DDDDD || %c == HHHHH) { return 5 }
  }
  if ($istok(%b,2,32) && $istok(%b,3,32) && $istok(%b,4,32) && $istok(%b,5,32) && $istok(%b,6,32)) {
    var %c = $remove(%d,$chr(32),2,3,4,5,6,7,8,9,10,11,12,13,14)
    if (%c == SSSSS || %c == CCCCC || %c == DDDDD || %c == HHHHH) { return 6 }
  }
  if ($istok(%b,3,32) && $istok(%b,4,32) && $istok(%b,5,32) && $istok(%b,6,32) && $istok(%b,7,32)) {
    var %c = $remove(%d,$chr(32),2,3,4,5,6,7,8,9,10,11,12,13,14)
    if (%c == SSSSS || %c == CCCCC || %c == DDDDD || %c == HHHHH) { return 7 }
  }
  if ($istok(%b,4,32) && $istok(%b,5,32) && $istok(%b,6,32) && $istok(%b,7,32) && $istok(%b,8,32)) {
    var %c = $remove(%d,$chr(32),2,3,4,5,6,7,8,9,10,11,12,13,14)
    if (%c == SSSSS || %c == CCCCC || %c == DDDDD || %c == HHHHH) { return 8 }
  }
  if ($istok(%b,5,32) && $istok(%b,6,32) && $istok(%b,7,32) && $istok(%b,8,32) && $istok(%b,9,32)) {
    var %c = $remove(%d,$chr(32),2,3,4,5,6,7,8,9,10,11,12,13,14)
    if (%c == SSSSS || %c == CCCCC || %c == DDDDD || %c == HHHHH) { return 9 }
  }
  if ($istok(%b,6,32) && $istok(%b,7,32) && $istok(%b,8,32) && $istok(%b,9,32) && $istok(%b,10,32)) {
    var %c = $remove(%d,$chr(32),2,3,4,5,6,7,8,9,10,11,12,13,14)
    if (%c == SSSSS || %c == CCCCC || %c == DDDDD || %c == HHHHH) { return 10 }
  }
  if ($istok(%b,7,32) && $istok(%b,8,32) && $istok(%b,9,32) && $istok(%b,10,32) && $istok(%b,11,32)) {
    var %c = $remove(%d,$chr(32),2,3,4,5,6,7,8,9,10,11,12,13,14)
    if (%c == SSSSS || %c == CCCCC || %c == DDDDD || %c == HHHHH) { return 11 }
  }
  if ($istok(%b,8,32) && $istok(%b,9,32) && $istok(%b,10,32) && $istok(%b,11,32) && $istok(%b,12,32)) {
    var %c = $remove(%d,$chr(32),2,3,4,5,6,7,8,9,10,11,12,13,14)
    if (%c == SSSSS || %c == CCCCC || %c == DDDDD || %c == HHHHH) { return 12 }
  }
  if ($istok(%b,9,32) && $istok(%b,10,32) && $istok(%b,11,32) && $istok(%b,12,32) && $istok(%b,13,32)) {
    var %c = $remove(%d,$chr(32),2,3,4,5,6,7,8,9,10,11,12,13,14)
    if (%c == SSSSS || %c == CCCCC || %c == DDDDD || %c == HHHHH) { return 13 }
  }
  if ($istok(%b,10,32) && $istok(%b,11,32) && $istok(%b,12,32) && $istok(%b,13,32) && $istok(%b,14,32)) {
    var %c = $remove(%d,$chr(32),2,3,4,5,6,7,8,9,10,11,12,13,14)
    if (%c == SSSSS || %c == CCCCC || %c == DDDDD || %c == HHHHH) { return 14 }
  }
}
alias -l fourofakind {
  var %a = $replace($1-,A,14,K,13,Q,12,J,11)
  if ($wildtok(%a,2*,0,32) == 4) { return 2 }
  if ($wildtok(%a,3*,0,32) == 4) { return 3 }
  if ($wildtok(%a,4*,0,32) == 4) { return 4 }
  if ($wildtok(%a,5*,0,32) == 4) { return 5 }
  if ($wildtok(%a,6*,0,32) == 4) { return 6 }
  if ($wildtok(%a,7*,0,32) == 4) { return 7 }
  if ($wildtok(%a,8*,0,32) == 4) { return 8 }
  if ($wildtok(%a,9*,0,32) == 4) { return 9 }
  if ($wildtok(%a,10*,0,32) == 4) { return 10 }
  if ($wildtok(%a,11*,0,32) == 4) { return 11 }
  if ($wildtok(%a,12*,0,32) == 4) { return 12 }
  if ($wildtok(%a,13*,0,32) == 4) { return 13 }
  if ($wildtok(%a,14*,0,32) == 4) { return 14 }
}
alias -l fullhouse {
  var %a = $replace($1-,A,14,K,13,Q,12,J,11)
  if ($wildtok(%a,2*,0,32) == 3) { 
    if ($wildtok(%a,3*,0,32) == 2) { return 3 }
    if ($wildtok(%a,4*,0,32) == 2) { return 4 }
    if ($wildtok(%a,5*,0,32) == 2) { return 5 }
    if ($wildtok(%a,6*,0,32) == 2) { return 6 }
    if ($wildtok(%a,7*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,3*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 3 }
    if ($wildtok(%a,4*,0,32) == 2) { return 4 }
    if ($wildtok(%a,5*,0,32) == 2) { return 5 }
    if ($wildtok(%a,6*,0,32) == 2) { return 6 }
    if ($wildtok(%a,7*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,4*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 5 }
    if ($wildtok(%a,3*,0,32) == 2) { return 5 }
    if ($wildtok(%a,5*,0,32) == 2) { return 5 }
    if ($wildtok(%a,6*,0,32) == 2) { return 6 }
    if ($wildtok(%a,7*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,5*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 5 }
    if ($wildtok(%a,3*,0,32) == 2) { return 5 }
    if ($wildtok(%a,4*,0,32) == 2) { return 5 }
    if ($wildtok(%a,6*,0,32) == 2) { return 6 }
    if ($wildtok(%a,7*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,6*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 6 }
    if ($wildtok(%a,3*,0,32) == 2) { return 6 }
    if ($wildtok(%a,4*,0,32) == 2) { return 6 }
    if ($wildtok(%a,5*,0,32) == 2) { return 6 }
    if ($wildtok(%a,7*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,7*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 7 }
    if ($wildtok(%a,3*,0,32) == 2) { return 7 }
    if ($wildtok(%a,4*,0,32) == 2) { return 7 }
    if ($wildtok(%a,5*,0,32) == 2) { return 7 }
    if ($wildtok(%a,6*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,8*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 8 }
    if ($wildtok(%a,3*,0,32) == 2) { return 8 }
    if ($wildtok(%a,4*,0,32) == 2) { return 8 }
    if ($wildtok(%a,5*,0,32) == 2) { return 8 }
    if ($wildtok(%a,6*,0,32) == 2) { return 8 }
    if ($wildtok(%a,7*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,9*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 9 }
    if ($wildtok(%a,3*,0,32) == 2) { return 9 }
    if ($wildtok(%a,4*,0,32) == 2) { return 9 }
    if ($wildtok(%a,5*,0,32) == 2) { return 9 }
    if ($wildtok(%a,6*,0,32) == 2) { return 9 }
    if ($wildtok(%a,7*,0,32) == 2) { return 9 }
    if ($wildtok(%a,8*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,10*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 10 }
    if ($wildtok(%a,3*,0,32) == 2) { return 10 }
    if ($wildtok(%a,4*,0,32) == 2) { return 10 }
    if ($wildtok(%a,5*,0,32) == 2) { return 10 }
    if ($wildtok(%a,6*,0,32) == 2) { return 10 }
    if ($wildtok(%a,7*,0,32) == 2) { return 10 }
    if ($wildtok(%a,8*,0,32) == 2) { return 10 }
    if ($wildtok(%a,9*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,11*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 11 }
    if ($wildtok(%a,3*,0,32) == 2) { return 11 }
    if ($wildtok(%a,4*,0,32) == 2) { return 11 }
    if ($wildtok(%a,5*,0,32) == 2) { return 11 }
    if ($wildtok(%a,6*,0,32) == 2) { return 11 }
    if ($wildtok(%a,7*,0,32) == 2) { return 11 }
    if ($wildtok(%a,8*,0,32) == 2) { return 11 }
    if ($wildtok(%a,9*,0,32) == 2) { return 11 }
    if ($wildtok(%a,10*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,12*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 12 }
    if ($wildtok(%a,3*,0,32) == 2) { return 12 }
    if ($wildtok(%a,4*,0,32) == 2) { return 12 }
    if ($wildtok(%a,5*,0,32) == 2) { return 12 }
    if ($wildtok(%a,6*,0,32) == 2) { return 12 }
    if ($wildtok(%a,7*,0,32) == 2) { return 12 }
    if ($wildtok(%a,8*,0,32) == 2) { return 12 }
    if ($wildtok(%a,9*,0,32) == 2) { return 12 }
    if ($wildtok(%a,10*,0,32) == 2) { return 12 }
    if ($wildtok(%a,11*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,13*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 13 }
    if ($wildtok(%a,3*,0,32) == 2) { return 13 }
    if ($wildtok(%a,4*,0,32) == 2) { return 13 }
    if ($wildtok(%a,5*,0,32) == 2) { return 13 }
    if ($wildtok(%a,6*,0,32) == 2) { return 13 }
    if ($wildtok(%a,7*,0,32) == 2) { return 13 }
    if ($wildtok(%a,8*,0,32) == 2) { return 13 }
    if ($wildtok(%a,9*,0,32) == 2) { return 13 }
    if ($wildtok(%a,10*,0,32) == 2) { return 13 }
    if ($wildtok(%a,11*,0,32) == 2) { return 13 }
    if ($wildtok(%a,12*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,14*,0,32) == 3) {
    if ($wildtok(%a,2*,0,32) == 2) { return 14 }
    if ($wildtok(%a,3*,0,32) == 2) { return 14 }
    if ($wildtok(%a,4*,0,32) == 2) { return 14 }
    if ($wildtok(%a,5*,0,32) == 2) { return 14 }
    if ($wildtok(%a,6*,0,32) == 2) { return 14 }
    if ($wildtok(%a,7*,0,32) == 2) { return 14 }
    if ($wildtok(%a,8*,0,32) == 2) { return 14 }
    if ($wildtok(%a,9*,0,32) == 2) { return 14 }
    if ($wildtok(%a,10*,0,32) == 2) { return 14 }
    if ($wildtok(%a,11*,0,32) == 2) { return 14 }
    if ($wildtok(%a,12*,0,32) == 2) { return 14 }
    if ($wildtok(%a,13*,0,32) == 2) { return 14 }
  }
}
alias -l flush {
  if ($remove($1-,$chr(32),A,K,Q,J,10) == SSSSS || $remove($1-,$chr(32),A,K,Q,J,10) == CCCCC || $remove($1-,$chr(32),A,K,Q,J,10) == DDDDD || $remove($1-,$chr(32),A,K,Q,J,10) == HHHHH) { return 14 } 
}
alias -l straight {
  var %a = 1, %b = $replace($remove($1-,S,C,D,H),A,14,J,11,Q,12,K,13)
  if ($istok(%b,14,32) && $istok(%b,2,32) && $istok(%b,3,32) && $istok(%b,4,32) && $istok(%b,5,32)) {
    return 5
  }
  if ($istok(%b,2,32) && $istok(%b,3,32) && $istok(%b,4,32) && $istok(%b,5,32) && $istok(%b,6,32)) {
    return 6
  }
  if ($istok(%b,3,32) && $istok(%b,4,32) && $istok(%b,5,32) && $istok(%b,6,32) && $istok(%b,7,32)) {
    return 7
  }
  if ($istok(%b,4,32) && $istok(%b,5,32) && $istok(%b,6,32) && $istok(%b,7,32) && $istok(%b,8,32)) {
    return 8
  }
  if ($istok(%b,5,32) && $istok(%b,6,32) && $istok(%b,7,32) && $istok(%b,8,32) && $istok(%b,9,32)) {
    return 9
  }
  if ($istok(%b,6,32) && $istok(%b,7,32) && $istok(%b,8,32) && $istok(%b,9,32) && $istok(%b,10,32)) {
    return 10
  }
  if ($istok(%b,7,32) && $istok(%b,8,32) && $istok(%b,9,32) && $istok(%b,10,32) && $istok(%b,11,32)) {
    return 11 
  }
  if ($istok(%b,8,32) && $istok(%b,9,32) && $istok(%b,10,32) && $istok(%b,11,32) && $istok(%b,12,32)) {
    return 12
  }
  if ($istok(%b,9,32) && $istok(%b,10,32) && $istok(%b,11,32) && $istok(%b,12,32) && $istok(%b,13,32)) {
    return 13
  }
  if ($istok(%b,10,32) && $istok(%b,11,32) && $istok(%b,12,32) && $istok(%b,13,32) && $istok(%b,14,32)) {
    return 14
  }
}
alias threeofakind {
  var %a = $replace($1-,A,14,K,13,Q,12,J,11)
  if ($wildtok(%a,2*,0,32) == 3) { return 2 }
  if ($wildtok(%a,3*,0,32) == 3) { return 3 }
  if ($wildtok(%a,4*,0,32) == 3) { return 4 }
  if ($wildtok(%a,5*,0,32) == 3) { return 5 }
  if ($wildtok(%a,6*,0,32) == 3) { return 6 }
  if ($wildtok(%a,7*,0,32) == 3) { return 7 }
  if ($wildtok(%a,8*,0,32) == 3) { return 8 }
  if ($wildtok(%a,9*,0,32) == 3) { return 9 }
  if ($wildtok(%a,10*,0,32) == 3) { return 10 }
  if ($wildtok(%a,11*,0,32) == 3) { return 11 }
  if ($wildtok(%a,12*,0,32) == 3) { return 12 }
  if ($wildtok(%a,13*,0,32) == 3) { return 13 }
  if ($wildtok(%a,14*,0,32) == 3) { return 14 }
}
alias -l twopairs {
  var %a = $replace($1-,A,14,K,13,Q,12,J,11)
  tokenize 32 %a
  if ($wildtok(%a,2*,0,32) == 2) {
    if ($wildtok(%a,3*,0,32) == 2) { return 3 }
    if ($wildtok(%a,4*,0,32) == 2) { return 4 }
    if ($wildtok(%a,5*,0,32) == 2) { return 5 }
    if ($wildtok(%a,6*,0,32) == 2) { return 6 }
    if ($wildtok(%a,7*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  }
  if ($wildtok(%a,3*,0,32) == 2) {
    if ($wildtok(%a,4*,0,32) == 2) { return 4 }
    if ($wildtok(%a,5*,0,32) == 2) { return 5 }
    if ($wildtok(%a,6*,0,32) == 2) { return 6 }
    if ($wildtok(%a,7*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 3 }
  }
  if ($wildtok(%a,4*,0,32) == 2) {
    if ($wildtok(%a,5*,0,32) == 2) { return 5 }
    if ($wildtok(%a,6*,0,32) == 2) { return 6 }
    if ($wildtok(%a,7*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 4 }
    if ($wildtok(%a,3*,0,32) == 2) { return 4 }
  }
  if ($wildtok(%a,5*,0,32) == 2) {
    if ($wildtok(%a,6*,0,32) == 2) { return 6 }
    if ($wildtok(%a,7*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 5 }
    if ($wildtok(%a,3*,0,32) == 2) { return 5 }
    if ($wildtok(%a,4*,0,32) == 2) { return 5 }
  }
  if ($wildtok(%a,6*,0,32) == 2) {
    if ($wildtok(%a,7*,0,32) == 2) { return 7 }
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 6 }
    if ($wildtok(%a,3*,0,32) == 2) { return 6 }
    if ($wildtok(%a,4*,0,32) == 2) { return 6 }
    if ($wildtok(%a,5*,0,32) == 2) { return 6 }
  }
  if ($wildtok(%a,7*,0,32) == 2) {
    if ($wildtok(%a,8*,0,32) == 2) { return 8 }
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 7 }
    if ($wildtok(%a,3*,0,32) == 2) { return 7 }
    if ($wildtok(%a,4*,0,32) == 2) { return 7 }
    if ($wildtok(%a,5*,0,32) == 2) { return 7 }
    if ($wildtok(%a,6*,0,32) == 2) { return 7 }
  }
  if ($wildtok(%a,8*,0,32) == 2) {
    if ($wildtok(%a,9*,0,32) == 2) { return 9 }
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 8 }
    if ($wildtok(%a,3*,0,32) == 2) { return 8 }
    if ($wildtok(%a,4*,0,32) == 2) { return 8 }
    if ($wildtok(%a,5*,0,32) == 2) { return 8 }
    if ($wildtok(%a,6*,0,32) == 2) { return 8 }
    if ($wildtok(%a,7*,0,32) == 2) { return 8 }
  }
  if ($wildtok(%a,9*,0,32) == 2) {
    if ($wildtok(%a,10*,0,32) == 2) { return 10 }
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 9 }
    if ($wildtok(%a,3*,0,32) == 2) { return 9 }
    if ($wildtok(%a,4*,0,32) == 2) { return 9 }
    if ($wildtok(%a,5*,0,32) == 2) { return 9 }
    if ($wildtok(%a,6*,0,32) == 2) { return 9 }
    if ($wildtok(%a,7*,0,32) == 2) { return 9 }
    if ($wildtok(%a,8*,0,32) == 2) { return 9 }
  }
  if ($wildtok(%a,10*,0,32) == 2) {
    if ($wildtok(%a,11*,0,32) == 2) { return 11 }
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 10 }
    if ($wildtok(%a,3*,0,32) == 2) { return 10 }
    if ($wildtok(%a,4*,0,32) == 2) { return 10 }
    if ($wildtok(%a,5*,0,32) == 2) { return 10 }
    if ($wildtok(%a,6*,0,32) == 2) { return 10 }
    if ($wildtok(%a,7*,0,32) == 2) { return 10 }
    if ($wildtok(%a,8*,0,32) == 2) { return 10 }
    if ($wildtok(%a,9*,0,32) == 2) { return 10 }
  }
  if ($wildtok(%a,11*,0,32) == 2) {
    if ($wildtok(%a,12*,0,32) == 2) { return 12 }
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 11 }
    if ($wildtok(%a,3*,0,32) == 2) { return 11 }
    if ($wildtok(%a,4*,0,32) == 2) { return 11 }
    if ($wildtok(%a,5*,0,32) == 2) { return 11 }
    if ($wildtok(%a,6*,0,32) == 2) { return 11 }
    if ($wildtok(%a,7*,0,32) == 2) { return 11 }
    if ($wildtok(%a,8*,0,32) == 2) { return 11 }
    if ($wildtok(%a,9*,0,32) == 2) { return 11 }
    if ($wildtok(%a,10*,0,32) == 2) { return 11 }
  }
  if ($wildtok(%a,12*,0,32) == 2) {
    if ($wildtok(%a,13*,0,32) == 2) { return 13 }
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 12 }
    if ($wildtok(%a,3*,0,32) == 2) { return 12 }
    if ($wildtok(%a,4*,0,32) == 2) { return 12 }
    if ($wildtok(%a,5*,0,32) == 2) { return 12 }
    if ($wildtok(%a,6*,0,32) == 2) { return 12 }
    if ($wildtok(%a,7*,0,32) == 2) { return 12 }
    if ($wildtok(%a,8*,0,32) == 2) { return 12 }
    if ($wildtok(%a,9*,0,32) == 2) { return 12 }
    if ($wildtok(%a,10*,0,32) == 2) { return 12 }
    if ($wildtok(%a,11*,0,32) == 2) { return 12 }
  }
  if ($wildtok(%a,13*,0,32) == 2) {
    if ($wildtok(%a,14*,0,32) == 2) { return 14 }
    if ($wildtok(%a,2*,0,32) == 2) { return 13 }
    if ($wildtok(%a,3*,0,32) == 2) { return 13 }
    if ($wildtok(%a,4*,0,32) == 2) { return 13 }
    if ($wildtok(%a,5*,0,32) == 2) { return 13 }
    if ($wildtok(%a,6*,0,32) == 2) { return 13 }
    if ($wildtok(%a,7*,0,32) == 2) { return 13 }
    if ($wildtok(%a,8*,0,32) == 2) { return 13 }
    if ($wildtok(%a,9*,0,32) == 2) { return 13 }
    if ($wildtok(%a,10*,0,32) == 2) { return 13 }
    if ($wildtok(%a,11*,0,32) == 2) { return 13 }
    if ($wildtok(%a,12*,0,32) == 2) { return 13 }
  }
  if ($wildtok(%a,14*,0,32) == 2) {
    if ($wildtok(%a,2*,0,32) == 2) { return 14 }
    if ($wildtok(%a,3*,0,32) == 2) { return 14 }
    if ($wildtok(%a,4*,0,32) == 2) { return 14 }
    if ($wildtok(%a,5*,0,32) == 2) { return 14 }
    if ($wildtok(%a,6*,0,32) == 2) { return 14 }
    if ($wildtok(%a,7*,0,32) == 2) { return 14 }
    if ($wildtok(%a,8*,0,32) == 2) { return 14 }
    if ($wildtok(%a,9*,0,32) == 2) { return 14 }
    if ($wildtok(%a,10*,0,32) == 2) { return 14 }
    if ($wildtok(%a,11*,0,32) == 2) { return 14 }
    if ($wildtok(%a,12*,0,32) == 2) { return 14 }
    if ($wildtok(%a,13*,0,32) == 2) { return 14 }
  }
}
alias -l pair {
  var %a = $replace($1-,J,11,Q,12,K,13,A,14)
  if ($wildtok(%a,14*,0,32) == 2) { return 14 }
  if ($wildtok(%a,13*,0,32) == 2) { return 13 }
  if ($wildtok(%a,12*,0,32) == 2) { return 12 }
  if ($wildtok(%a,11*,0,32) == 2) { return 11 }
  if ($wildtok(%a,10*,0,32) == 2) { return 10 }
  if ($wildtok(%a,9*,0,32) == 2) { return 9 }
  if ($wildtok(%a,8*,0,32) == 2) { return 8 }
  if ($wildtok(%a,7*,0,32) == 2) { return 7 }
  if ($wildtok(%a,6*,0,32) == 2) { return 6 }
  if ($wildtok(%a,5*,0,32) == 2) { return 5 }
  if ($wildtok(%a,4*,0,32) == 2) { return 4 }
  if ($wildtok(%a,3*,0,32) == 2) { return 3 }
  if ($wildtok(%a,2*,0,32) == 2) { return 2 }
}
alias -l highscore {
  var %old, %k = $2
  if (!$exists($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.poker.scores.txt"))) { write -c $+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.poker.scores.txt") }
  if ($read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.poker.scores.txt"),nw,$3 *)) { %old = $readn | write $+(-dl,$readn) $+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.poker.scores.txt") }
  var %a = 1, %b, %c = n
  while ($read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.poker.scores.txt"),n,%a) && %c == n) {
    %b = $read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.poker.scores.txt"),n,%a)
    if ($4 > $gettok(%b,2,32)) { %c = y | if (%a < %old) { hadd $1 $+(%k,.moveup) %a } | else { hdel $1 $+(%k,.moveup) } | write $+(-il,%a) $+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.poker.scores.txt") $3 $4 }
    inc %a
  }
  if (%c == n) { write $+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.poker.scores.txt") $3 $4 }
}
alias -l top10 {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  var %a = 1, %b, %c
  while ($read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.poker.scores.txt"),%a) && %a <= 10) {
    %c = $read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.poker.scores.txt"),%a)
    %b = $addtok(%b,$+($chr(40),$ord($readn),$chr(41),$chr(32),$gettok(%c,1,32),$chr(32),[$,$bytes($gettok(%c,2,32),b),]),32)
    inc %a
  }
  if (%b) { sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ *** $2 poker top10 players *** $chr(3) | sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ %b $chr(3) }
}
alias -l getcard {
  :start
  var %a = $replace($r(1,10),10,j,1,A,j,10), %s = $replace($r(1,4),1,C,2,S,3,D,4,H)
  var %card = $+(%a,%s)
  if (!$istok($hget($1,$+($2,.cards)),%card,32) && $hget($1,$+($2,.cards))) { goto start }
  hadd $1 $+($2,.cards) $remtok($hget($1,$+($2,.cards)),%card,1,32)
  return %card
}
alias -l roundplayers {
  var %p = $hget(cgsb,$+($1,.prefix))
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker has now started... $chr(3)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Rules: 5 card draw. $chr(3)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You have 30secs to join the game by typing $+(,%p,poker) join. $chr(3)
  .timerpoker -o 1 30 startpoker $1-
}
alias -l startpoker {
  hadd $1 $+($2,.cards) AS AH AD AC KS KH KD KC QS QH QD QC JS JH JD JC 10S 10H 10D 10C 9S 9H 9D 9C 8S 8H 8D 8C 7S 7H 7D 7C 6S 6H 6D 6C 5S 5H 5D 5C 4S 4H 4D 4C 3S 3H 3D 3C 2S 2H 2D 2C
  hadd $1 $+($2,.start) $ctime 
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  if ($numtok($hget($1,$+($2,.poker.players)),32) <= 1) { sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker stopped. Not enough players. $chr(3) | endpoker $1-2 }
  elseif ($numtok($hget($1,$+($2,.poker.players)),32) > 5) { sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker stopped. Too many players. $chr(3) | endpoker $1-2 }
  else { 
    var %a = 1, %b
    while ($gettok($hget($1,$+($2,.poker.players)),%a,32)) {
      %b = $ifmatch
      if (!$hget($1,$+($2,.,%b,.money))) { hadd $1 $+($2,.,%b,.money) 1000 }
      hdec $1 $+($2,.,%b,.money) 10
      hinc $1 $+($2,.pot) 10
      if ($hget($1,$+($2,.,%b,.money)) < 10) {
        hadd $1 $+($2,.poker.players) $remtok($hget($1,$+($2,.poker.players)),%b,1,32)
        sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ %b has lost all of their money. $chr(3)
        hadd $1 $+($2,.poker.players) $remtok($hget($1,$+($2,.poker.players)),%b,32)
        hdel $1 $+($2,.,%b,.money)
        if ($numtok($hget($1,$+($2,.poker.players)),32) == 1) { endpoker $1 $2 %b | sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ The game is now over! Not enough players left to continue! $chr(3) | return }
      }
      hadd $1 $+($2,.,%b,.hand) $getcard($1,$2) $getcard($1,$2) $getcard($1,$2) $getcard($1,$2) $getcard($1,$2)
      hdel $1 $+($2,.,%b,.discard)
      hdel $1 $+($2,.,%b,.bid)
      sockwrite -n $1 notice %b $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+($,$bytes($hget($1,$+($2,.,%b,.money)),b),) / $+(,$hget($1,$+($2,.,%b,.hand)),)
      sockwrite -n $1 notice %b $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You may now bid.
      inc %a
    }
    hadd $1 $+($2,.bid) 10
    sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ The pot is $+(,$+($,$bytes($hget($1,$+($2,.pot)),b)),.) $chr(3)
  }
}
alias -l endingpoker {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ The hand is now over! $chr(3)
  var %a = 1, %b = $hget($1,$+($2,.poker.players)), %c, %h, %high, %o, %topcard, %total, %total2, %end, %total.high, %finish, %top, %top.total, %top.gadget, %full.gadget
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    %h = $hget($1,$+($2,.,%c,.hand))
    %topcard = $topcard(%h)
    if ($royalflush(%h)) { %high = 10 | %top.gadget = $ifmatch }
    elseif ($straightflush(%h)) { %high = 9 | %top.gadget = $ifmatch }
    elseif ($fourofakind(%h)) { %high = 8 | %top.gadget = $ifmatch }
    elseif ($fullhouse(%h)) { %high = 7 | %top.gadget = $ifmatch }
    elseif ($flush(%h)) { %high = 6 | %top.gadget = $ifmatch }
    elseif ($straight(%h)) { %high = 5 | %top.gadget = $ifmatch }
    elseif ($threeofakind(%h)) { %high = 4 | %top.gadget = $ifmatch }
    elseif ($twopairs(%h)) { %high = 3 | %top.gadget = $ifmatch }
    elseif ($pair(%h)) { %high = 2 | %top.gadget = $ifmatch }
    else { %high = 1 }
    if (!%total.high || %high > %total.high) { %total.high = %high | %top.o = %c | %total.topcard = %topcard | %top.end = $replace(%high,10,Royal Flush,9,Straight Flush,8,Four Of A Kind,7,Full House,6,Flush,5,Straight,4,Three Of A Kind,3,Two Pairs,2,Pair,1,Nothing) }
    elseif (%high == %total.high) { if (!%full.gadget || %top.gadget > %full.gadget) { %top.o = %c | %full.gadget = %top.gadget | %top.end = $replace(%high,10,Royal Flush,9,Straight Flush,8,Four Of A Kind,7,Full House,6,Flush,5,Straight,4,Three Of A Kind,3,Two Pairs,2,Pair,1,Nothing) } }
    callhand $1 $2 %c %h
    inc %a
  }
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ And the winner is... $chr(3)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,%top.o,) with $+(,%top.end,,$chr(32),$chr(40),$replace(%top.gadget,14,A's high,13,K's high,12,Q's high,11,J's high,10,10's high,9,9's high,8,8's high,7,7's high,6,6's high,5,5's high,4,4's high,3,3's high),$chr(41)) $iif(!%top.gadget,High Card $+(,$iif(%total.topcard,$ifmatch,%topcard),!)) $chr(3)
  hinc $1 $+($2,.,%top.o,.money) $hget($1,$+($2,.pot))
  highscore $1 $2 %top.o $hget($1,$+($2,.,%top.o,.money))
  sockwrite -n $1 notice %top.o $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You now have $+($,$bytes($hget($1,$+($2,.,%top.o,.money)),b),!)

  var %a = 1, %b = $hget($1,$+($2,.poker.players))
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    %h = $hget($1,$+($2,.,%c,.money))
    if (%c != %top.o) { sockwrite -n $1 notice %c $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You have $+(,$+($,$bytes(%h,b)),.) $chr(3) }
    inc %a
  }
  endpoker $1-3
}
alias -l callhand { 
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$3,) had $+(,$4-,)
}
alias -l parsetoken {
  return $replace($remove($1,C,S,D,H),A,14,K,13,Q,12,J,11)
}
alias -l topcard {
  var %a = $replace($1-,A,14,K,13,Q,12,J,11)
  return $replace($gettok($sorttok(%a,32,nr),1,32),14,A,13,K,12,Q,11,J)
}
alias -l endpoker {
  .timerpoker off
  hadd $1 $+($2,.poker.status) Off
  hdel $1 $+($2,.pot)
  hdel $1 $+($2,.start)
  hdel $1 $+($2,.done)
  hdel $1 $+($2,.bid)
  var %a = 1, %b = $hget($1,$+($2,.poker.players))
  while ($gettok(%b,%a,32)) {
    hdel $1 $+($2,.,$ifmatch,.discard)
    hdel $1 $+($2,.,$ifmatch,.bid)
    inc %a
  }
  hdel $1 $+($2,.poker.players)
}
alias -l getplayers {
  ;1=sockname,2=channel
  var %a = 1, %b = $hget($1,$+($2,.poker.players)), %f, %g = 0
  while (%a <= %b) {
    %f = $gettok(%b,%a,32)
    if ($hget($1,$+($2,.,%f,.bid)) == 2) { inc %g }
    dec %a
  }
  return %g
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:poker:{
  var %c = $hget(cgsb,buffer)
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %p = $hget(cgsb,$+($cgsbsock,.prefix))
  tokenize 32 %c
  if ($2 == privmsg) {
    if ($+(:,$hget(cgsb,$+($cgsbsock,.prefix)),*) iswm $4) {
      var %a = $hget($cgsbsock,access)
      if ($+(:,%p,poker) == $4) {
        if (top10 == $5) {
          top10 $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33)
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($5 == On || $5 == Off) {
          if (%a < $getcom(poker)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Permission Denied. You do not have enough access to use this command. $chr(3) }
          elseif ($hget($cgsbsock,$+($3,.poker.status)) == $5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker is already $5 $chr(3) }
          else { 
            hadd $cgsbsock $+($3,.poker.status) $5
            sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker is now: $+(,$5,.)
            if ($5 == On) { 
              roundplayers $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33)
              sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$gettok($mid($1,2,$len($1)),1,33),) has entered the game. $chr(3)
              hadd $cgsbsock $+($3,.poker.players) $addtok( $hget($cgsbsock,$+($3,.poker.players)),$gettok($mid($1,2,$len($1)),1,33) ,32)
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker Commands: $+(%p,poker) fold, $+(%p,poker) bid, $+(%p,poker) discard, Get ready for poker!
            }
            else { 
              endpoker $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33) 
            }
          }
        }
        elseif (place == $5) {
          var %g = $read($+(",$scriptdir,$cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.poker.scores.txt"),nw,$gettok($mid($1,2,$len($1)),1,33) *)
          if (%g) { sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+($chr(40),$ord($readn),$chr(41)) $gettok($mid($1,2,$len($1)),1,33) $+([$,$bytes($gettok(%g,2,32),b),]) }
          else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You don't have a score recorded. $chr(3) }
        }
        elseif ($5 == join) {
          if ($hget($cgsbsock,$+($3,.poker.status)) != On) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker is not on! $chr(3) }
          elseif ($hget($cgsbsock,$+($3,.start))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Game in progress. Please wait awhile then try again. $chr(3) }
          elseif ($istok($hget($cgsbsock,$+($3,.poker.players)),$gettok($mid($1,2,$len($1)),1,33),32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You have already joined the game! $chr(3) }
          elseif ($numtok($hget($cgsbsock,$+($3,.poker.players)),32) == 5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Sorry, all slots are full for this game. $chr(3) }
          else { sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$gettok($mid($1,2,$len($1)),1,33),) has entered the game. $chr(3) | hadd $cgsbsock $+($3,.poker.players) $addtok( $hget($cgsbsock,$+($3,.poker.players)),$gettok($mid($1,2,$len($1)),1,33) ,32) | sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker Commands: $+(%p,poker) fold, $+(%p,poker) bid, $+(%p,poker) discard, Get ready for poker! }
        }
        elseif ($5 == fold) {
          if ($hget($cgsbsock,$+($3,.poker.status)) != On) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker is not on! $chr(3) }
          elseif (!$istok($hget($cgsbsock,$+($3,.poker.players)),$gettok($mid($1,2,$len($1)),1,33),32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You are not currently playing! $chr(3) }
          else { 
            var %j = $remtok($hget($cgsbsock,$+($3,.poker.players)),$gettok($mid($1,2,$len($1)),1,33),1,32)
            hadd $cgsbsock $+($3,.poker.players) %j
            sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $gettok($mid($1,2,$len($1)),1,33) has left the game. $chr(3) 
            if ($numtok($hget($cgsbsock,$+($3,.poker.players)),32) == 1) { 
              sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Not enough players left to continue! $chr(3)
              endingpoker $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33)
            }
            elseif ($getplayers($cgsbsock,$3) == $numtok($hget($cgsbsock,$+($3,.poker.players)),32)) {
              endingpoker $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33)
            }
          }
        }
        elseif ($5 == discard) {
          if ($hget($cgsbsock,$+($3,.poker.status)) != On) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker is not on! $chr(3) | return }
          elseif ($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.discard))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You already discarded! $chr(3) }
          elseif (!$istok($hget($cgsbsock,$+($3,.poker.players)),$gettok($mid($1,2,$len($1)),1,33),32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You are not currently playing! $chr(3) | return }
          elseif (!$6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No cards entered. $chr(3) | return }
          elseif ($11) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You may only discard up to 5 cards! $chr(3) }
          elseif (!$hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.bid))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You must bid before you can discard. $chr(3) }
          else {
            var %a = 1, %b = $6-, %j = 0, %d, %h
            while ($gettok(%b,%a,32)) {
              %d = $ifmatch
              if (%d !isnum 1-5) { inc %j | %h = %h %d }
              inc %a
            }
            if (%j > 0) { goto next }
            var %a = 1, %b = $6-, %c
            while ($gettok(%b,%a,32)) {
              %c = $ifmatch
              hadd $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand) $puttok($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand)),$getcard($cgsbsock,$3),%c,32)
              inc %a
            }
            :next
            if (%j > 0) {
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You dont have cards: $+(%h,!) $chr(3) 
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+($,$bytes($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.money)),b),) / $+(,$hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand)),)
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Please discard again.
            }
            else {
              hadd $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.discard) $ctime
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+($,$bytes($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.money)),b),) / $+(,$hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand)),)
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You may now bid.
            }
          }
        }
        elseif ($5 == bid) {
          if ($hget($cgsbsock,$+($3,.poker.status)) != On) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Poker is not on! $chr(3) | return }
          elseif ($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.bid)) >= 2) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You already bidded this round! $chr(3) | return }
          elseif (!$istok($hget($cgsbsock,$+($3,.poker.players)),$gettok($mid($1,2,$len($1)),1,33),32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You arm not currently playing! $chr(3) | return }
          elseif (!$6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No money value entered. $chr(3) | return }
          elseif ($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,32),.money)) < $6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not have enough money to bid that amount! $chr(3) | return }
          elseif ($6 < 10) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Minimum bid is $!10. $chr(3) | return }
          elseif ($6 < $hget($cgsbsock,$+($3,.bid))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Minimum bid is $+(,$hget($cgsbsock,$+($3,.bid)),.) $chr(3) | return }
          elseif ($6 > $hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.money))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You don't have enough money! $chr(3) | return }
          hinc $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.bid) | hadd $cgsbsock $+($3,.bid) $6 | hinc $cgsbsock $+($3,.pot) $6 | hdec $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.money) $6 | sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$gettok($mid($1,2,$len($1)),1,33),) increases the pot to $+(,$+($,$bytes($hget($cgsbsock,$+($3,.pot)),b)),.)
          if ($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.bid)) == 2) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Now lets see who won! $chr(3) | sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$gettok($mid($1,2,$len($1)),1,33),) is now waiting for the other players... $chr(3) | hadd $cgsbsock $+($3,.done) $addtok($hget($cgsbsock,$+($3,.done)),$gettok($mid($1,2,$len($1)),1,33),32) }
          elseif ($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.bid)) == 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You may now discard. $chr(3) }
          if ($numtok($hget($cgsbsock,$+($3,.done)),32) == $numtok($hget($cgsbsock,$+($3,.poker.players)),32)) { .timer -o 1 10 endingpoker $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33) }
        }
      }
    }
  }
}
